import { Carrier } from './carrier';
import { Defer } from '../defer';
import { createIDType } from '../id';
var nextSEQ = createIDType();
export class CarrierEffect extends Carrier {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.seq = nextSEQ(), this.defer = new Defer(), _temp;
  }

  done() {
    this.dispatch(this);
    return this.defer.done.then(({
      result
    }) => result);
  }

  fail() {
    this.dispatch(this);
    return this.defer.fail.then(({
      error
    }) => error);
  }

  promise() {
    this.dispatch(this);
    return Promise.race([this.done(), this.fail().then(err => Promise.reject(err))]);
  }

}
//# sourceMappingURL=carrier-effect.js.map