import { Dispose } from '../defer';
import { createIDType } from '../id';
var nextID = createIDType();
export class Carrier {
  constructor() {
    this.id = nextID();
    this.dispose = new Dispose();
  }

  dispatched() {
    return this.dispose.done;
  }

  plain() {
    return {
      type: this.type,
      payload: this.payload
    };
  }

  send() {
    this.dispatch(this);
    return this.dispatched();
  }

}

function id(x) {
  return x;
}

export function carrier(typeId, type, payload, dispatch) {
  var result = new Carrier();
  result.payload = payload;
  result.type = type;
  result.typeId = typeId;
  result.dispatch = dispatch;
  return result;
}
export function is(e)
/*::%checks*/
{
  return typeof e === 'object' && e != null && typeof e.type === 'string' && e instanceof Carrier;
}
//# sourceMappingURL=carrier.js.map