import { CarrierEffect } from './carrier-effect';
export function runEffect(payload, dispatch, effect) {
  var init = new CarrierEffect();
  init.defer.done.then(dispatch);
  init.defer.fail.then(dispatch);
  init.payload = payload;
  init.type = effect.getType();
  init.typeId = effect.typeId;
  init.dispatch = dispatch;
  init.dispatched().then(payload => effect.thunk(payload).then(value => {
    var {
      done
    } = effect;
    done.used += 1;
    var result = done.actionConstructor(done.typeId, done.getType(), {
      params: payload,
      result: value
    }, dispatch);
    dispatch(result);
    result.dispatched().then(rs => init.defer.resolved(rs));
  }, value => {
    var {
      fail
    } = effect;
    fail.used += 1;
    var result = fail.actionConstructor(fail.typeId, fail.getType(), {
      params: payload,
      error: value
    }, dispatch);
    dispatch(result);
    result.dispatched().then(rs => init.defer.rejected(rs));
  }));
  return init;
}
//# sourceMappingURL=run-effect.js.map