import { createStore, applyMiddleware } from 'redux';
import { is } from './carrier/carrier';
import { Store } from './store';
import { incSeq } from './id';

function middleware({
  store,
  // dispatch,
  getState,
  next,
  data
}) {
  var unwrapped = data.plain();
  next(unwrapped);
  store.seq = incSeq(store.seq);
  store.update$.next({
    data,
    state: getState()
  });
  data.dispose.disposed(data.payload);
  return data;
}

function middlewareCurry(store) {
  return ({
    dispatch,
    getState
  }) => next => data => {
    if (!is(data)) return next(data);
    if (!store.uniq.isUniq(data)) return;
    return middleware({
      dispatch,
      getState,
      next,
      data,
      store
    });
  };
}

export function effectorEnhancer(createStore) {
  return (reducer, preloadedState, enhancer) => {
    var storeContext = new Store();
    storeContext.scopeName = [];
    var store = createStore(reducer, preloadedState, enhancer);
    storeContext.injector.setStore(store);
    var dispatch = store.dispatch;
    var middlewareAPI = {
      getState: () => (console.log(store.getState()), store.getState()),
      dispatch: action => dispatch(action)
    };
    dispatch = middlewareCurry(storeContext)(middlewareAPI)(store.dispatch);
    storeContext.dispatch = dispatch;
    storeContext.stateGetter = store.getState;
    storeContext.reduxSubscribe = store.subscribe;
    storeContext.getState = storeContext.stateGetter;
    storeContext.subscribe = storeContext.reduxSubscribe;
    storeContext.replaceReducer = store.replaceReducer;
    return storeContext;
  };
}
export function getStore(description, reducer) {
  var storeContext = createStore(reducer, effectorEnhancer);
  storeContext.scopeName = [description];
  storeContext.injector.saveStatic(reducer); // store.subscribe(() => { storeContext.state$.next(store.getState()) })

  return storeContext;
}
//# sourceMappingURL=middleware.js.map