"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CarrierEffect = void 0;

var _carrier = require("./carrier");

var _defer = require("../defer");

var _id = require("../id");

var nextSEQ = (0, _id.createIDType)();

class CarrierEffect extends _carrier.Carrier {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.seq = nextSEQ(), this.defer = new _defer.Defer(), _temp;
  }

  done() {
    this.dispatch(this);
    return this.defer.done.then(({
      result
    }) => result);
  }

  fail() {
    this.dispatch(this);
    return this.defer.fail.then(({
      error
    }) => error);
  }

  promise() {
    this.dispatch(this);
    return Promise.race([this.done(), this.fail().then(err => Promise.reject(err))]);
  }

}

exports.CarrierEffect = CarrierEffect;
//# sourceMappingURL=carrier-effect.js.map