"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.carrier = carrier;
exports.is = is;
exports.Carrier = void 0;

var _defer = require("../defer");

var _id = require("../id");

var nextID = (0, _id.createIDType)();

class Carrier {
  constructor() {
    this.id = nextID();
    this.dispose = new _defer.Dispose();
  }

  dispatched() {
    return this.dispose.done;
  }

  plain() {
    return {
      type: this.type,
      payload: this.payload
    };
  }

  send() {
    this.dispatch(this);
    return this.dispatched();
  }

}

exports.Carrier = Carrier;

function id(x) {
  return x;
}

function carrier(typeId, type, payload, dispatch) {
  var result = new Carrier();
  result.payload = payload;
  result.type = type;
  result.typeId = typeId;
  result.dispatch = dispatch;
  return result;
}

function is(e)
/*::%checks*/
{
  return typeof e === 'object' && e != null && typeof e.type === 'string' && e instanceof Carrier;
}
//# sourceMappingURL=carrier.js.map