"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Defer = exports.Dispose = void 0;

var _id = require("./id");

var nextID = (0, _id.createIDType)();
var never = new Promise(() => {});

class Dispose {
  disposed(data) {
    this.done = Promise.resolve(data);
    this.status = 'disposed';
    var rs = this.
    /*::#*/
    rs;
    rs(data);
  }

  constructor() {
    this.id = nextID();
    this.status = 'unknown';
    var done = new Promise(rs => {
      this.
      /*::#*/
      rs = rs;
    });
    this.done = done;
  }

}

exports.Dispose = Dispose;

class Defer {
  promise() {
    return Promise.race([this.done.then(onResolve), this.fail.then(onReject)]).then(result => {
      if (result.status) return result.done;
      return Promise.reject(result.fail);
    });
  }

  resolved(data) {
    this.done = Promise.resolve(data);
    this.fail = never;
    this.status = 'resolved';
    var rs = this.
    /*::#*/
    rs;
    rs(data);
  }

  rejected(error) {
    this.done = never;
    this.fail = Promise.resolve(error);
    this.status = 'rejected';
    var rj = this.
    /*::#*/
    rj;
    rj(error);
  }

  constructor() {
    this.id = nextID();
    this.status = 'unknown';
    var done = new Promise(rs => {
      this.
      /*::#*/
      rs = rs;
    });
    var fail = new Promise(rj => {
      this.
      /*::#*/
      rj = rj;
    });
    this.done = done;
    this.fail = fail;
  }

}

exports.Defer = Defer;

function onResolve(done) {
  return {
    done,
    status: true
  };
}

function onReject(fail) {
  return {
    fail,
    status: false
  };
}
//# sourceMappingURL=defer.js.map