"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.effectorEnhancer = effectorEnhancer;
exports.getStore = getStore;

var _redux = require("redux");

var _carrier = require("./carrier/carrier");

var _store = require("./store");

var _id = require("./id");

function middleware({
  store,
  // dispatch,
  getState,
  next,
  data
}) {
  var unwrapped = data.plain();
  next(unwrapped);
  store.seq = (0, _id.incSeq)(store.seq);
  store.update$.next({
    data,
    state: getState()
  });
  data.dispose.disposed(data.payload);
  return data;
}

function middlewareCurry(store) {
  return ({
    dispatch,
    getState
  }) => next => data => {
    if (!(0, _carrier.is)(data)) return next(data);
    if (!store.uniq.isUniq(data)) return;
    return middleware({
      dispatch,
      getState,
      next,
      data,
      store
    });
  };
}

function effectorEnhancer(createStore) {
  return (reducer, preloadedState, enhancer) => {
    var storeContext = new _store.Store();
    storeContext.scopeName = [];
    var store = createStore(reducer, preloadedState, enhancer);
    storeContext.injector.setStore(store);
    var dispatch = store.dispatch;
    var middlewareAPI = {
      getState: () => (console.log(store.getState()), store.getState()),
      dispatch: action => dispatch(action)
    };
    dispatch = middlewareCurry(storeContext)(middlewareAPI)(store.dispatch);
    storeContext.dispatch = dispatch;
    storeContext.stateGetter = store.getState;
    storeContext.reduxSubscribe = store.subscribe;
    storeContext.getState = storeContext.stateGetter;
    storeContext.subscribe = storeContext.reduxSubscribe;
    storeContext.replaceReducer = store.replaceReducer;
    return storeContext;
  };
}

function getStore(description, reducer) {
  var storeContext = (0, _redux.createStore)(reducer, effectorEnhancer);
  storeContext.scopeName = [description];
  storeContext.injector.saveStatic(reducer); // store.subscribe(() => { storeContext.state$.next(store.getState()) })

  return storeContext;
}
//# sourceMappingURL=middleware.js.map